<template>
  <div
    ref="input"
    style="width: 200px; color: #000000"
    class="input"
    contenteditable="true"
  ></div>
</template>
<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { useRoute } from 'vue-router';

// Definicja emoiToSrc
const emoiToSrc: { [key: string]: string } = {
  '_)$': 'smile.png',
  '3)$': 'laugh.png',
  // ':D': 'grin.png',
  '8D': 'cool.png',
  '8E': 'sunglasses.png',
  ':handwave:': 'handwave.png',
};

const emit = defineEmits(['content']);
const content = ref<string | undefined>('');
const input = ref<HTMLDivElement | null>(null);
const route = useRoute();
onMounted(() => {
  if (route.query.operation === 'wave') {
    const img = new Image();
    img.setAttribute('height', '40px');
    img.setAttribute('width', 'auto');
    img.src = '/emois/' + emoiToSrc[':handwave:'];
    input.value?.appendChild(img);
    placeCaretAtEnd();
    emit('content', input.value?.innerHTML);
  }

  input.value?.addEventListener('keyup', (e: KeyboardEvent) => {
    console.log(e.key);
    handleKeyDown(e);
  });
});

function handleKeyDown(e: KeyboardEvent) {
  console.log(e);
  const text = input.value?.innerHTML;
  let img;
  let regEmoi;
  content.value = text?.replace(/<img\s.*src="(.)[.s]*\/>/g, '$1');

  for (const emoi in emoiToSrc) {
    regEmoi = new RegExp((emoi + '$').replace(')', '\\)'));

    if (text?.match(regEmoi)) {
      if (!input.value) return;
      input.value.innerHTML = text.substring(0, text.length - 2);
      img = new Image();
      img.setAttribute('height', '20');
      img.setAttribute('width', 'auto');
      img.src = '/emois/' + emoi.replace('$', '') + '.png';
      input.value.appendChild(img);
      placeCaretAtEnd();
      break;
    }
  }
  emit('content', input.value?.innerHTML);
}

function placeCaretAtEnd() {
  if (input.value) {
    input.value.focus();
    const selection = window.getSelection();
    if (selection && typeof document.createRange !== 'undefined') {
      const range = document.createRange();
      range.selectNodeContents(input.value);
      range.collapse(false);
      selection.removeAllRanges();
      selection.addRange(range);
    }
  }
}
</script>
<style scoped lang="scss">
.input {
  z-index: 100;
  padding: 10px;
  height: 120px;
  width: 200px !important;
  overflow: auto;
  font-size: 20px;
  background: white;
  outline: 1px solid rgba($color: #0f0f0f, $alpha: 1) !important;
  font-family: Roboto Mono;
}
</style>
